Package: alkahest
Title: Pre-Processing XY Data from Experimental Methods
Version: 1.3.0
Authors@R: c(
    person("Nicolas", "Frerebeau", , "nicolas.frerebeau@u-bordeaux-montaigne.fr", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5759-4944")),
    person("Brice", "Lebrun", role = "art",
           comment = c(ORCID = "0000-0001-7503-8685", "Logo designer")),
    person("Université Bordeaux Montaigne", role = "fnd",
           comment = c(ROR = "03pbgwk21")),
    person("CNRS", role = "fnd",
           comment = c(ROR = "02feahw73"))
  )
Maintainer: Nicolas Frerebeau <nicolas.frerebeau@u-bordeaux-montaigne.fr>
Description: A lightweight, dependency-free toolbox for pre-processing XY
    data from experimental methods (i.e. any signal that can be measured
    along a continuous variable). This package provides methods for
    baseline estimation and correction, smoothing, normalization,
    integration and peaks detection. Baseline correction methods includes
    polynomial fitting as described in Lieber and Mahadevan-Jansen (2003)
    <doi:10.1366/000370203322554518>, Rolling Ball algorithm after Kneen
    and Annegarn (1996) <doi:10.1016/0168-583X(95)00908-6>, SNIP algorithm
    after Ryan et al. (1988) <doi:10.1016/0168-583X(88)90063-8>, 4S Peak
    Filling after Liland (2015) <doi:10.1016/j.mex.2015.02.009> and more.
License: GPL (>= 3)
URL: https://codeberg.org/tesselle/alkahest,
        https://packages.tesselle.org/alkahest/
BugReports: https://codeberg.org/tesselle/alkahest/issues
Depends: R (>= 3.5.0)
Imports: grDevices, methods, stats, utils
Suggests: knitr, markdown, Matrix, tinytest
VignetteBuilder: knitr
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
X-schema.org-isPartOf: https://www.tesselle.org
X-schema.org-keywords: spectroscopy, archaeometry, r-package
Collate: 'AllGenerics.R' 'alkahest-internal.R' 'alkahest-package.R'
        'baseline.R' 'data.R' 'integrate.R' 'peaks.R' 'replace.R'
        'resample.R' 'rescale.R' 'signal.R' 'smooth.R' 'windows.R'
        'xrd.R'
NeedsCompilation: no
Packaged: 2025-02-25 21:35:08 UTC; nicolas
Author: Nicolas Frerebeau [aut, cre] (<https://orcid.org/0000-0001-5759-4944>),
  Brice Lebrun [art] (<https://orcid.org/0000-0001-7503-8685>, Logo
    designer),
  Université Bordeaux Montaigne [fnd] (03pbgwk21),
  CNRS [fnd] (02feahw73)
Repository: CRAN
Date/Publication: 2025-02-25 22:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 16:18:27 UTC; unix

Package: alkahest
Title: Pre-Processing XY Data from Experimental Methods
Version: 1.3.0
Authors@R: c(
    person("Nicolas", "Frerebeau", , "nicolas.frerebeau@u-bordeaux-montaigne.fr", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5759-4944")),
    person("Brice", "Lebrun", role = "art",
           comment = c(ORCID = "0000-0001-7503-8685", "Logo designer")),
    person("Université Bordeaux Montaigne", role = "fnd",
           comment = c(ROR = "03pbgwk21")),
    person("CNRS", role = "fnd",
           comment = c(ROR = "02feahw73"))
  )
Maintainer: Nicolas Frerebeau <nicolas.frerebeau@u-bordeaux-montaigne.fr>
Description: A lightweight, dependency-free toolbox for pre-processing XY
    data from experimental methods (i.e. any signal that can be measured
    along a continuous variable). This package provides methods for
    baseline estimation and correction, smoothing, normalization,
    integration and peaks detection. Baseline correction methods includes
    polynomial fitting as described in Lieber and Mahadevan-Jansen (2003)
    <doi:10.1366/000370203322554518>, Rolling Ball algorithm after Kneen
    and Annegarn (1996) <doi:10.1016/0168-583X(95)00908-6>, SNIP algorithm
    after Ryan et al. (1988) <doi:10.1016/0168-583X(88)90063-8>, 4S Peak
    Filling after Liland (2015) <doi:10.1016/j.mex.2015.02.009> and more.
License: GPL (>= 3)
URL: https://codeberg.org/tesselle/alkahest,
        https://packages.tesselle.org/alkahest/
BugReports: https://codeberg.org/tesselle/alkahest/issues
Depends: R (>= 3.5.0)
Imports: grDevices, methods, stats, utils
Suggests: knitr, markdown, Matrix, tinytest
VignetteBuilder: knitr
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
X-schema.org-isPartOf: https://www.tesselle.org
X-schema.org-keywords: spectroscopy, archaeometry, r-package
Collate: 'AllGenerics.R' 'alkahest-internal.R' 'alkahest-package.R'
        'baseline.R' 'data.R' 'integrate.R' 'peaks.R' 'replace.R'
        'resample.R' 'rescale.R' 'signal.R' 'smooth.R' 'windows.R'
        'xrd.R'
NeedsCompilation: no
Packaged: 2025-02-25 21:35:08 UTC; nicolas
Author: Nicolas Frerebeau [aut, cre] (<https://orcid.org/0000-0001-5759-4944>),
  Brice Lebrun [art] (<https://orcid.org/0000-0001-7503-8685>, Logo
    designer),
  Université Bordeaux Montaigne [fnd] (03pbgwk21),
  CNRS [fnd] (02feahw73)
Repository: CRAN
Date/Publication: 2025-02-25 22:00:02 UTC
Built: R 4.6.0; ; 2026-04-26 10:32:02 UTC; unix

# Generated by roxygen2: do not edit by hand

exportMethods(baseline_asls)
exportMethods(baseline_linear)
exportMethods(baseline_peakfilling)
exportMethods(baseline_polynomial)
exportMethods(baseline_rollingball)
exportMethods(baseline_rubberband)
exportMethods(baseline_snip)
exportMethods(integrate_rectangle)
exportMethods(integrate_trapezoid)
exportMethods(ka2_strip_penalized)
exportMethods(peaks_find)
exportMethods(peaks_fwhm)
exportMethods(replace_negative)
exportMethods(replace_threshold)
exportMethods(resample_bin)
exportMethods(resample_down)
exportMethods(resample_interpolate)
exportMethods(rescale_area)
exportMethods(rescale_max)
exportMethods(rescale_min)
exportMethods(rescale_range)
exportMethods(rescale_snv)
exportMethods(rescale_total)
exportMethods(rescale_transform)
exportMethods(signal_bind)
exportMethods(signal_correct)
exportMethods(signal_drift)
exportMethods(signal_mean)
exportMethods(signal_select)
exportMethods(signal_shift)
exportMethods(signal_slice)
exportMethods(smooth_likelihood)
exportMethods(smooth_loess)
exportMethods(smooth_rectangular)
exportMethods(smooth_savitzky)
exportMethods(smooth_triangular)
exportMethods(smooth_whittaker)
exportMethods(window_sliding)
exportMethods(window_tumbling)
importFrom(grDevices,chull)
importFrom(grDevices,xy.coords)
importFrom(methods,.valueClassTest)
importFrom(methods,callGeneric)
importFrom(methods,setGeneric)
importFrom(methods,setMethod)
importFrom(stats,approx)
importFrom(stats,lm)
importFrom(stats,mad)
importFrom(stats,poly)
importFrom(stats,predict)
importFrom(stats,smooth.spline)
importFrom(stats,spline)
importFrom(stats,weighted.mean)
importFrom(utils,head)
importFrom(utils,tail)

<!-- README.md is generated from README.Rmd. Please edit that file -->

# alkahest <img width=120px src="man/figures/logo.png" align="right" />

<!-- badges: start -->

[![Dependencies](https://tinyverse.netlify.app/badge/alkahest)](https://cran.r-project.org/package=alkahest)

<a href="https://tesselle.r-universe.dev" class="pkgdown-devel"><img
src="https://tesselle.r-universe.dev/badges/alkahest"
alt="r-universe" /></a>
<a href="https://cran.r-project.org/package=alkahest"
class="pkgdown-release"><img
src="https://www.r-pkg.org/badges/version/alkahest"
alt="CRAN Version" /></a> <a
href="https://cran.r-project.org/web/checks/check_results_alkahest.html"
class="pkgdown-release"><img
src="https://badges.cranchecks.info/worst/alkahest.svg"
alt="CRAN checks" /></a>
<a href="https://cran.r-project.org/package=alkahest"
class="pkgdown-release"><img
src="https://cranlogs.r-pkg.org/badges/alkahest"
alt="CRAN Downloads" /></a>

[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.7081524.svg)](https://doi.org/10.5281/zenodo.7081524)
<!-- badges: end -->

## Overview

**alkahest** is a lightweight, dependency-free toolbox for
pre-processing XY data from experimental methods (i.e. any signal that
can be measured along a continuous variable). It provides methods for
baseline estimation and correction, smoothing, normalization,
integration and peaks detection.

- Baseline estimation methods: Linear, Polynomial (Lieber and
  Mahadevan-Jansen 2003), Asymmetric Least Squares (Eilers and Boelens
  2005), Rolling Ball (Kneen and Annegarn 1996), Rubberband, SNIP
  (Morháč et al. 1997; Morháč and Matoušek 2008; Ryan et al. 1988), 4S
  Peak Filling (Liland 2015).
- Smoothing methods: Rectangular, Triangular, Loess, Savitzky-Golay
  Filter (Gorry 1990; Savitzky and Golay 1964), Whittaker (Eilers 2003),
  Penalized Likelihood (De Rooi et al. 2014)

------------------------------------------------------------------------

To cite alkahest in publications use:

Frerebeau N (2025). *alkahest: Pre-Processing XY Data from Experimental
Methods*. Université Bordeaux Montaigne, Pessac, France.
<doi:10.5281/zenodo.7081524> <https://doi.org/10.5281/zenodo.7081524>, R
package version 1.3.0, <https://packages.tesselle.org/alkahest/>.

This package is a part of the tesselle project
<https://www.tesselle.org>.

## Installation

You can install the released version of **alkahest** from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("alkahest")
```

And the development version from [Codeberg](https://codeberg.org/) with:

``` r
# install.packages("remotes")
remotes::install_git("https://codeberg.org/tesselle/alkahest")
```

## Usage

``` r
## Load the package
library(alkahest)
```

**alkahest** expects the input data to be in the simplest form (a
two-column matrix or data frame, a two-element list or two numeric
vectors).

``` r
## X-ray diffraction
data("XRD")

## 4S Peak Filling baseline
baseline <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, sparse = TRUE)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(baseline, type = "l", col = "red")
```

![](man/figures/README-baseline-1.png)<!-- -->

``` r
## Correct baseline
XRD <- signal_drift(XRD, lag = baseline, subtract = TRUE)

## Find peaks
peaks <- peaks_find(XRD, SNR = 3, m = 11)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(peaks, type = "p", pch = 16, col = "red")
```

![](man/figures/README-peaks-1.png)<!-- -->

``` r
## Simulate data
set.seed(12345)
x <- seq(-4, 4, length = 100)
y <- dnorm(x)
z <- y + rnorm(100, mean = 0, sd = 0.01) # Add some noise

## Plot raw data
plot(x, z, type = "l", xlab = "", ylab = "", main = "Raw data")
lines(x, y, type = "l", lty = 2, col = "red")

## Savitzky–Golay filter
smooth <- smooth_savitzky(x, z, m = 21, p = 2)
plot(smooth, type = "l", xlab = "", ylab = "", main = "Savitzky–Golay filter")
lines(x, y, type = "l", lty = 2, col = "red")
```

<img src="man/figures/README-smooth-1.png" width="50%" /><img src="man/figures/README-smooth-2.png" width="50%" />

## Contributing

Please note that the **alkahest** project is released with a
[Contributor Code of Conduct](https://www.tesselle.org/conduct.html). By
contributing to this project, you agree to abide by its terms.

## References

<div id="refs" class="references csl-bib-body hanging-indent"
entry-spacing="0">

<div id="ref-barnes1989" class="csl-entry">

Barnes, R. J., M. S. Dhanoa, and Susan J. Lister. 1989. “Standard Normal
Variate Transformation and De-Trending of Near-Infrared Diffuse
Reflectance Spectra.” *Applied Spectroscopy* 43 (5): 772–77.
<https://doi.org/10.1366/0003702894202201>.

</div>

<div id="ref-derooi2014" class="csl-entry">

De Rooi, Johan J., Niek M. Van Der Pers, Ruud W. A. Hendrikx, Rob
Delhez, Amarante J. Böttger, and Paul H. C. Eilers. 2014. “Smoothing of
<span class="nocase">X-ray</span> Diffraction Data and *K* α
<sub>2</sub> Elimination Using Penalized Likelihood and the Composite
Link Model.” *Journal of Applied Crystallography* 47 (3): 852–60.
<https://doi.org/10.1107/S1600576714005809>.

</div>

<div id="ref-eilers2003" class="csl-entry">

Eilers, Paul H. C. 2003. “A Perfect Smoother.” *Analytical Chemistry* 75
(14): 3631–36. <https://doi.org/10.1021/ac034173t>.

</div>

<div id="ref-eilers2005" class="csl-entry">

Eilers, Paul H. C., and Hans F. M. Boelens. 2005. “Baseline Correction
with Asymmetric Least Squares Smoothing.” October 21, 2005.

</div>

<div id="ref-gorry1990" class="csl-entry">

Gorry, Peter A. 1990. “General Least-Squares Smoothing and
Differentiation by the Convolution (Savitzky-Golay) Method.” *Analytical
Chemistry* 62 (6): 570–73. <https://doi.org/10.1021/ac00205a007>.

</div>

<div id="ref-kneen1996" class="csl-entry">

Kneen, M. A., and H. J. Annegarn. 1996. “Algorithm for Fitting XRF, SEM
and <span class="nocase">PIXE X-ray</span> Spectra Backgrounds.”
*Nuclear Instruments and Methods in Physics Research Section B: Beam
Interactions with Materials and Atoms* 109–110 (April): 209–13.
<https://doi.org/10.1016/0168-583X(95)00908-6>.

</div>

<div id="ref-lieber2003" class="csl-entry">

Lieber, Chad A., and Anita Mahadevan-Jansen. 2003. “Automated Method for
Subtraction of Fluorescence from Biological Raman Spectra.” *Applied
Spectroscopy* 57 (11): 1363–67.
<https://doi.org/10.1366/000370203322554518>.

</div>

<div id="ref-liland2015" class="csl-entry">

Liland, Kristian Hovde. 2015. “4S Peak Filling – Baseline Estimation by
Iterative Mean Suppression.” *MethodsX* 2: 135–40.
<https://doi.org/10.1016/j.mex.2015.02.009>.

</div>

<div id="ref-morhac1997" class="csl-entry">

Morháč, Miroslav, Ján Kliman, Vladislav Matoušek, Martin Veselský, and
Ivan Turzo. 1997. “Background Elimination Methods for Multidimensional
Coincidence γ-Ray Spectra.” *Nuclear Instruments and Methods in Physics
Research Section A: Accelerators, Spectrometers, Detectors and
Associated Equipment* 401 (1): 113–32.
<https://doi.org/10.1016/S0168-9002(97)01023-1>.

</div>

<div id="ref-morhac2008" class="csl-entry">

Morháč, Miroslav, and Vladislav Matoušek. 2008. “Peak Clipping
Algorithms for Background Estimation in Spectroscopic Data.” *Applied
Spectroscopy* 62 (1): 91–106.
<https://doi.org/10.1366/000370208783412762>.

</div>

<div id="ref-ryan1988" class="csl-entry">

Ryan, C. G., E. Clayton, W. L. Griffin, S. H. Sie, and D. R. Cousens.
1988. “SNIP, a Statistics-Sensitive Background Treatment for the
Quantitative Analysis of PIXE Spectra in Geoscience Applications.”
*Nuclear Instruments and Methods in Physics Research Section B: Beam
Interactions with Materials and Atoms* 34 (3): 396–402.
<https://doi.org/10.1016/0168-583X(88)90063-8>.

</div>

<div id="ref-savitzky1964" class="csl-entry">

Savitzky, Abraham., and M. J. E. Golay. 1964. “Smoothing and
Differentiation of Data by Simplified Least Squares Procedures.”
*Analytical Chemistry* 36 (8): 1627–39.
<https://doi.org/10.1021/ac60214a047>.

</div>

</div>

## X-ray diffraction
data("XRD")

## Subset from 20 to 70 degrees
XRD <- signal_select(XRD, from = 20, to = 70)

## Plot spectrum
plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## Rolling Ball baseline
baseline <- baseline_rollingball(XRD, m = 201, s = 151)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(baseline, type = "l", col = "red")

## gamma-ray spectrometry
data("BEGe")

## Plot spectrum
plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")

## Subset from 2.75 keV to 200 keV
BEGe_1 <- signal_select(BEGe, from = 3, to = 200)

## Plot spectrum
plot(BEGe_1, type = "l", xlab = "Energy (keV)", ylab = "Count")

## Subset from the 20th to the 1250th value
BEGe_2 <- signal_slice(BEGe, subset = 20:1250)

## Plot spectrum
plot(BEGe_2, type = "l", xlab = "Energy (keV)", ylab = "Count")

if (at_home()) {
  data("XRD")

  # Linear baseline ============================================================
  linear <- baseline_linear(XRD, points = c(10, 70))

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(linear, type = "l", col = "red")

  expect_equal_to_reference(linear, file = "_snaps/baseline_linear.rds")

  # Polynomial baseline ========================================================
  XRD2 <- signal_select(XRD, from = 20, to = 70)
  polynomial <- baseline_polynomial(XRD2, d = 4, tolerance = 0.02, stop = 1000)

  # plot(XRD2, type = "l", xlab = "", ylab = "")
  # lines(polynomial, type = "l", col = "red")

  expect_equal_to_reference(polynomial, file = "_snaps/baseline_polynomial.rds")

  # Rolling Ball baseline ======================================================
  rollingball <- baseline_rollingball(XRD, m = 201, s = 151)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(rollingball, type = "l", col = "red")

  expect_equal_to_reference(rollingball, file = "_snaps/baseline_rollingball.rds")

  # Rubberband baseline ========================================================
  rubberband <- baseline_rubberband(XRD)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(rubberband, type = "l", col = "red")

  expect_equal_to_reference(rubberband, file = "_snaps/baseline_rubberband.rds")

  # SNIP baseline ==============================================================
  snip <- baseline_snip(XRD, LLS = FALSE, decreasing = FALSE)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip, type = "l", col = "red")

  expect_equal_to_reference(snip, file = "_snaps/baseline_snip.rds")

  snip_LLS <- baseline_snip(XRD, LLS = TRUE, decreasing = FALSE, n = 50)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip_LLS, type = "l", col = "red")

  expect_equal_to_reference(snip_LLS, file = "_snaps/baseline_snip_LLS.rds")

  snip_decreasing <- baseline_snip(XRD, LLS = TRUE, decreasing = TRUE, n = 50)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip_decreasing, type = "l", col = "red")

  expect_equal_to_reference(snip_decreasing, file = "_snaps/baseline_snip_decreasing.rds")

  # 4S Peak Filling ============================================================
  peak <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, sparse = TRUE)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(peak, type = "l", col = "red")

  expect_equal_to_reference(peak, file = "_snaps/baseline_peakfilling.rds")
}

if (at_home()) {
  data("XRD")

  # Linear baseline ============================================================
  linear <- baseline_linear(XRD, points = c(10, 70))

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(linear, type = "l", col = "red")

  expect_equal_to_reference(linear, file = "_snaps/baseline_linear.rds")

  # Polynomial baseline ========================================================
  XRD2 <- signal_select(XRD, from = 20, to = 70)
  polynomial <- baseline_polynomial(XRD2, d = 4, tolerance = 0.02, stop = 1000)

  # plot(XRD2, type = "l", xlab = "", ylab = "")
  # lines(polynomial, type = "l", col = "red")

  expect_equal_to_reference(polynomial, file = "_snaps/baseline_polynomial.rds")

  # Rolling Ball baseline ======================================================
  rollingball <- baseline_rollingball(XRD, m = 201, s = 151)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(rollingball, type = "l", col = "red")

  expect_equal_to_reference(rollingball, file = "_snaps/baseline_rollingball.rds")

  # Rubberband baseline ========================================================
  rubberband <- baseline_rubberband(XRD)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(rubberband, type = "l", col = "red")

  expect_equal_to_reference(rubberband, file = "_snaps/baseline_rubberband.rds")

  # SNIP baseline ==============================================================
  snip <- baseline_snip(XRD, LLS = FALSE, decreasing = FALSE)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip, type = "l", col = "red")

  expect_equal_to_reference(snip, file = "_snaps/baseline_snip.rds")

  snip_LLS <- baseline_snip(XRD, LLS = TRUE, decreasing = FALSE, n = 50)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip_LLS, type = "l", col = "red")

  expect_equal_to_reference(snip_LLS, file = "_snaps/baseline_snip_LLS.rds")

  snip_decreasing <- baseline_snip(XRD, LLS = TRUE, decreasing = TRUE, n = 50)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(snip_decreasing, type = "l", col = "red")

  expect_equal_to_reference(snip_decreasing, file = "_snaps/baseline_snip_decreasing.rds")

  # 4S Peak Filling ============================================================
  peak <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, sparse = TRUE)

  # plot(XRD, type = "l", xlab = "", ylab = "")
  # lines(peak, type = "l", col = "red")

  expect_equal_to_reference(peak, file = "_snaps/baseline_peakfilling.rds")

  # AsLS =======================================================================
  asls <- baseline_asls(XRD, p = 0.005, lambda = 10^7)

  plot(XRD, type = "l", xlab = "", ylab = "")
  lines(asls, type = "l", col = "red")

  expect_equal_to_reference(asls, file = "_snaps/baseline_asls.rds")
}

\dontrun{
## X-ray diffraction
data("XRD")

## Subset from 20 to 40 degrees
XRD <- signal_select(XRD, from = 20, to = 40)

## Plot diffractogram
plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## Penalized likelihood smoothing
lambda <- seq(from = 1, to = 8, length.out = 40)
lambda <- 10^lambda

likelihood <- smooth_likelihood(XRD, lambda = lambda, d = 3)
lines(likelihood, col = "red")

## Strip ka2
ka2 <- ka2_strip_penalized(XRD, lambda = lambda, tau = 0.5, nseg = 1)
lines(ka2, col = "blue")
}

## Simulate data with some noise
x <- seq(-4, 4, length = 100)
y <- dnorm(x) + rnorm(100, mean = 0, sd = 0.01)

## Plot spectrum
plot(x, y, type = "l", xlab = "", ylab = "")

## Rectangular smoothing
unweighted <- smooth_rectangular(x, y, m = 3)
plot(unweighted, type = "l", xlab = "", ylab = "")

## Triangular smoothing
weighted <- smooth_triangular(x, y, m = 5)
plot(weighted, type = "l", xlab = "", ylab = "")

## Loess smoothing
loess <- smooth_loess(x, y, span = 0.75)
plot(loess, type = "l", xlab = "", ylab = "")

## Savitzky–Golay filter
savitzky <- smooth_savitzky(x, y, m = 21, p = 2)
plot(savitzky, type = "l", xlab = "", ylab = "")

## Whittaker smoothing
whittaker <- smooth_whittaker(x, y, lambda = 1600, d = 2)
plot(whittaker, type = "l", xlab = "", ylab = "")

## gamma-ray spectrometry
data("BEGe")

## Subset from 2.75 to 200 keV
BEGe <- signal_select(BEGe, from = 3, to = 200)

## Plot spectrum
plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")

## Rubberband baseline
baseline <- baseline_rubberband(BEGe)

plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")
lines(baseline, type = "l", col = "red")

## X-ray diffraction
data("XRD")

## 4S Peak Filling baseline
baseline <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, sparse = TRUE)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(baseline, type = "l", col = "red")

## X-ray diffraction
data("XRD")

XRD1 <- signal_drift(XRD, lag = 1500)

## Bind
XRD_bind <- signal_bind(XRD, XRD1)
XRD_bind[, 1:10]

## Mean
XRD_mean <- signal_mean(XRD, XRD1)

plot(NULL, type = "l", xlim = c(10, 70) , ylim = c(3000, 36000),
     xlab = expression(2*theta), ylab = "Count")
lines(XRD, type = "l")
lines(XRD1, type = "l")
lines(XRD_mean, type = "l", col = "red")

## Calculate the area under the sine curve from 0 to pi
# integrate(f = function(x) x^3, lower = 0, upper = 2)
x <- seq(0, 2, len = 101)
y <- x^3

plot(x, y, type = "l")

integrate_rectangle(x, y, right = FALSE) # 3.9204
integrate_rectangle(x, y, right = TRUE) # 4.0804
integrate_trapezoid(x, y) # 4.0004

## X-ray diffraction
data("XRD")

## Plot spectrum
plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## Bin by 3
XRD_bin_mean <- resample_bin(XRD, by = 3, f = mean)
XRD_bin_min <- resample_bin(XRD, by = 3, f = min)

plot(XRD, type = "l", xlim = c(25, 35),
     xlab = expression(2*theta), ylab = "Count")
lines(XRD_bin_mean, type = "l", col = "red")
lines(XRD_bin_min, type = "l", col = "green")

## Downsample by 10
XRD_down <- resample_down(XRD, by = 10)

plot(XRD, type = "l", xlim = c(20, 40),
     xlab = expression(2*theta), ylab = "Count")
lines(XRD_down, type = "l", col = "red")

## Linearly interpolate
XRD_approx <- resample_interpolate(XRD, from = 20, to = 40, by = 0.02)

plot(XRD, type = "l", xlim = c(20, 40),
     xlab = expression(2*theta), ylab = "Count")
lines(XRD_approx, type = "l", col = "red")

## gamma-ray spectrometry
data("BEGe")

## Subset from 2.75 to 200 keV
BEGe <- signal_select(BEGe, from = 3, to = 200)

## Drift
baseline <- baseline_snip(BEGe)
BEGe_drif <- signal_drift(BEGe, lag = baseline, subtract = TRUE)

plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")
lines(BEGe_drif, type = "l", col = "red")

## Correct
BEGe_corr <- signal_correct(BEGe, method = "SNIP")

plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")
lines(BEGe_corr, type = "l", col = "red")

## X-ray diffraction
data("XRD")

## 4S Peak Filling baseline
baseline <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, sparse = TRUE)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(baseline, type = "l", col = "red")

## Correct baseline
XRD <- signal_drift(XRD, lag = baseline, subtract = TRUE)

## Find peaks
peaks <- peaks_find(XRD, SNR = 3, m = 11)

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(peaks, type = "p", pch = 16, col = "red")
abline(h = attr(peaks, "noise"), lty = 2) # noise threshold

## Half-Width at Half-Maximum
x <- seq(-4, 4, length = 1000)
y <- dnorm(x)

peaks_fwhm(x, y, center = 0) # Expected: 2 * sqrt(2 * log(2))

## X-ray diffraction
data("XRD")

## Plot spectrum
plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## Linear baseline
baseline <- baseline_linear(XRD, points = c(25, 34))

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")
lines(baseline, type = "l", col = "red")

## Correct baseline
XRD$count <- XRD$count - baseline$y

plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## gamma-ray spectrometry
data("BEGe")

## Subset from 2.75 to 200 keV
BEGe <- signal_select(BEGe, from = 3, to = 200)

## Plot spectrum
plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")

## Normalize by area under the curve
BEGe_area <- rescale_area(BEGe)
plot(BEGe_area, type = "l", xlab = "Energy (keV)", ylab = "Count")
integrate_rectangle(BEGe)
integrate_rectangle(BEGe_area)

## Rescale so that intensities sum to 1
BEGe_total <- rescale_total(BEGe, total = 1)
plot(BEGe_total, type = "l", xlab = "Energy (keV)", ylab = "Count")

## Rescale intensities to 0-1
BEGe_range <- rescale_range(BEGe, min = 0, max = 1)
plot(BEGe_range, type = "l", xlab = "Energy (keV)", ylab = "Count")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(alkahest)

## ----raw----------------------------------------------------------------------
## Load data
data("XRD") # X-ray diffraction

## Subset from 20 to 70 degrees
XRD <- signal_select(XRD, from = 20, to = 70)

## Y plot limits
ylim <- c(0, max(XRD$y))

## ----linear, fig.width=7, fig.height=6, fig.cap="Linear baseline."------------
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline between 25 and 34 degrees
baseline <- baseline_linear(XRD, points = c(25, 34))

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----polynomial, fig.width=7, fig.height=6, fig.cap="Polynomial baseline."----
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_polynomial(XRD, d = 4, tolerance = 0.02, stop = 1000)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----asls, fig.width=7, fig.height=6, fig.cap="Asymmetric Least Squares Smoothing."----
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = "Energy (keV)", ylab = "Count")
abline(h = 0, lty = "dashed")

## AsLS baseline
baseline <- baseline_asls(XRD, p = 0.005, lambda = 10^7)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----rollingball, fig.width=7, fig.height=6, fig.cap="Rolling Ball baseline."----
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_rollingball(XRD, m = 201, s = 151)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----rubberband, fig.width=7, fig.height=6, fig.cap="Rubberband baseline."----
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_rubberband(XRD)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----snip, fig.width=7, fig.height=6, fig.cap="SNIP baseline."----------------
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_snip(XRD, LLS = FALSE, decreasing = FALSE, n = 100)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## ----peakfilling, fig.width=7, fig.height=6, fig.cap="4S Peak Filling."-------
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = "Energy (keV)", ylab = "Count")
abline(h = 0, lty = "dashed")

## 4S Peak Filling baseline
baseline <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, 
                                 lambda = 1000, d = 3, sparse = TRUE)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")

## Length of the data series
n <- 10

## Progressive sliding windows
sliding <- window_sliding(n = n, m = 5)

plot(NULL, xlim = c(1, n), ylim = c(1, 10.5), xlab = "Index", ylab = "Window")
for (i in seq_along(sliding)) {
  w <- sliding[[i]]
  text(x = w, y = rep(i, length(w)), labels = w, pos = 3)
  lines(w, rep(i, length(w)), type = "l", lwd = 2)
}

## Tumbling windows
## (compare with drop = TRUE)
tumbling <- window_tumbling(n = n, m = 3, drop = FALSE)

plot(NULL, xlim = c(1, n), ylim = c(1, 5.5), xlab = "Index", ylab = "Window")
for (i in seq_along(tumbling)) {
  w <- tumbling[[i]]
  text(x = w, y = rep(i, length(w)), labels = w, pos = 3)
  lines(w, rep(i, length(w)), type = "l", lwd = 2)
}

## Raman spectrometry
data("Raman")

## Subset from 200 to 800 1/cm
Raman <- signal_select(Raman, from = 200, to = 800)

## Plot spectrum
plot(Raman, type = "l", xlab = "Raman shift", ylab = "Intensity")

## Normalize SNV
Raman_snv <- rescale_snv(Raman)
plot(Raman_snv, type = "l", xlab = "Raman shift", ylab = "Intensity")

## gamma-ray spectrometry
data("BEGe")

## Subset from 2.75 to 200 keV
BEGe <- signal_select(BEGe, from = 3, to = 200)

## Drift
BEGe_plus <- signal_drift(BEGe, lag = 250)
BEGe_minus <- signal_drift(BEGe, lag = 250, subtract = TRUE)

plot(BEGe, type = "l", xlab = "Energy (keV)", ylab = "Count")
lines(BEGe_plus, type = "l", col = "red")
lines(BEGe_minus, type = "l", col = "green")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(alkahest)

## ----raw, fig.width=7, fig.height=5, fig.cap="Simulated data."----------------
## Simulate data
set.seed(12345)
x <- seq(-4, 4, length = 100)
y <- dnorm(x)
z <- y + rnorm(100, mean = 0, sd = 0.01) # Add some noise

## Plot raw data
plot(x, z, type = "l", xlab = "", ylab = "", las = 1)
lines(x, y, type = "l", lty = 2, col = "red")

## ----unweighted, fig.width=7, fig.height=6, fig.cap="Rectangular smoothing."----
unweighted <- smooth_rectangular(x, z, m = 3)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(unweighted, type = "l", xlab = "", ylab = "") 
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - unweighted$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)

## ----weighted, fig.width=7, fig.height=6, fig.cap="Triangular smoothing."-----
weighted <- smooth_triangular(x, z, m = 5)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(weighted, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - weighted$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)

## ----loess, fig.width=7, fig.height=6, fig.cap="Loess smoothing."-------------
loess <- smooth_loess(x, z, span = 0.2)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(loess, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - loess$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)

## ----savitzky, fig.width=7, fig.height=6, fig.cap="Savitzky–Golay filter."----
savitzky <- smooth_savitzky(x, z, m = 21, p = 2)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(savitzky, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - savitzky$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)

## ----whittaker, fig.width=7, fig.height=6, fig.cap="Whittaker smoothing."-----
whittaker <- smooth_whittaker(x, z, lambda = 1000, d = 3, sparse = TRUE)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(whittaker, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - whittaker$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)

## X-ray diffraction
data("XRD")

## Plot spectrum
plot(XRD, type = "l", xlab = expression(2*theta), ylab = "Count")

## Shift by one degree
XRD_offset <- signal_shift(XRD, lag = 1)
lines(XRD_offset, type = "l", col = "red")

data("XRD")

# Bin ==========================================================================
## Resample by 10
XRD_bin <- resample_bin(XRD, by = 3)
expect_equal(lengths(XRD_bin), c(x = 996, y = 996))

# Downsample ===================================================================
## Resample by 10
XRD_down <- resample_down(XRD, by = 10)
expect_equal(lengths(XRD_down), c(x = 299, y = 299))

# Interpolate ==================================================================
if (at_home()) {
  ## Linearly interpolate
  interpolate <- resample_interpolate(XRD, from = 20, to = 40, by = 0.1)

  interpolate_summary <- summary(as.data.frame(interpolate))
  expect_equal_to_reference(interpolate_summary, file = "_snaps/resample_interpolate.rds")

  # plot(XRD, type = "l", xlim = c(20, 40), xlab = "", ylab = "")
  # lines(interpolate, type = "l", col = "red")
}

data("XRD")

# Replace values below an arbitrary threshold ==================================
XRD_threshold <- replace_threshold(XRD, threshold = 4000, value = 5000)
expect_true(all(XRD_threshold$y > 4000))

# Replace values below a computed threshold ====================================
XRD_threshold <- replace_threshold(XRD, threshold = mean, value = 5000)
expect_true(all(XRD_threshold$y > mean(XRD$count)))

# Replace negative values ======================================================
XRD_rescale <- rescale_min(XRD, min = -1000)
expect_true(any(XRD_rescale$y < 0))

XRD_negative <- replace_negative(XRD_rescale, value = 0)
expect_false(any(XRD_negative$y < 0))

data("BEGe")
data("XRD")

# Bind =========================================================================
if (at_home()) {
  XRD1 <- signal_drift(XRD, lag = 1500)
  expect_equal_to_reference(signal_bind(XRD, XRD1)[, 1:20], file = "_snaps/signal_bind.rds")

  XRD1 <- signal_slice(XRD1, subset = 1:100)
  expect_error(signal_mean(XRD, XRD1))
}

# Mean =========================================================================
if (at_home()) {
  XRD1 <- signal_drift(XRD, lag = 1500)
  expect_equal_to_reference(signal_mean(XRD, XRD1), file = "_snaps/signal_mean.rds")

  XRD1 <- signal_slice(XRD1, subset = 1:100)
  expect_error(signal_mean(XRD, XRD1))
}

# Select =======================================================================
## Subset from 2.75 keV to 200 keV
BEGe_select <- signal_select(BEGe, from = 3, to = 200)

expect_true(min(BEGe_select$x) > 2)
expect_true(max(BEGe_select$x) < 201)

# Slice ========================================================================
## Subset from the 20th to the 1250th value (1231 values)
BEGe_slice <- signal_slice(BEGe, subset = 20:1250)

expect_length(BEGe_slice$x, 1231)
expect_length(BEGe_slice$y, 1231)

# Shift ========================================================================
## Shift by one degree
offset <- signal_shift(XRD, lag = 1)
expect_equal(offset$x, XRD$theta + 1)

# plot(XRD, type = "l", xlab = "", ylab = "")
# lines(offset, type = "l", col = "red")

# Drift ========================================================================
## Drift by 500
XRD_plus <- signal_drift(XRD, lag = 250)
expect_equal(XRD_plus$y, XRD$count + 250)

XRD_minus <- signal_drift(XRD, lag = XRD, subtract = TRUE)
expect_equal(XRD_minus$y, rep(0, nrow(XRD)))

# plot(XRD, type = "l", xlab = "", ylab = "")
# lines(XRD_plus, type = "l", col = "red")

# Correct ======================================================================
if (at_home()) {
  rubberband <- signal_correct(XRD, method = "rubberband")

  # plot(XRD, type = "l", ylim = c(0, 35500), xlab = "", ylab = "")
  # lines(rubberband, type = "l", col = "red")

  expect_equal_to_reference(rubberband, file = "_snaps/signal_correct.rds")
}

---
title: "Smoothing Methods"
author: "N. Frerebeau"
date: "`r Sys.Date()`"
output:
  markdown::html_format:
    options:
      toc: true
      number_sections: true
vignette: >
  %\VignetteIndexEntry{Smoothing Methods}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(alkahest)
```

```{r raw, fig.width=7, fig.height=5, fig.cap="Simulated data."}
## Simulate data
set.seed(12345)
x <- seq(-4, 4, length = 100)
y <- dnorm(x)
z <- y + rnorm(100, mean = 0, sd = 0.01) # Add some noise

## Plot raw data
plot(x, z, type = "l", xlab = "", ylab = "", las = 1)
lines(x, y, type = "l", lty = 2, col = "red")
```

# Rectangular smoothing

```{r unweighted, fig.width=7, fig.height=6, fig.cap="Rectangular smoothing."}
unweighted <- smooth_rectangular(x, z, m = 3)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(unweighted, type = "l", xlab = "", ylab = "") 
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - unweighted$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)
```

# Triangular smoothing

```{r weighted, fig.width=7, fig.height=6, fig.cap="Triangular smoothing."}
weighted <- smooth_triangular(x, z, m = 5)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(weighted, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - weighted$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)
```

# Loess smoothing

```{r loess, fig.width=7, fig.height=6, fig.cap="Loess smoothing."}
loess <- smooth_loess(x, z, span = 0.2)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(loess, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - loess$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)
```

# Savitzky-Golay filter

```{r savitzky, fig.width=7, fig.height=6, fig.cap="Savitzky–Golay filter."}
savitzky <- smooth_savitzky(x, z, m = 21, p = 2)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(savitzky, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - savitzky$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)
```

# Whittaker smoothing

```{r whittaker, fig.width=7, fig.height=6, fig.cap="Whittaker smoothing."}
whittaker <- smooth_whittaker(x, z, lambda = 1000, d = 3, sparse = TRUE)

par(mar = c(3, 3, 1, 1) + 0.1, las = 1)
layout(matrix(c(1, 2), nrow = 2, ncol = 1), heights = c(2, 1))

plot(whittaker, type = "l", xlab = "", ylab = "")
lines(x, y, type = "l", lty = 2, col = "red")

plot(x, y - whittaker$y, ylim = c(-0.03, 0.03), type = "l", xlab = "", ylab = "")
abline(h = 0, lty = 2)
```

---
title: "Baseline Estimation"
author: "N. Frerebeau"
date: "`r Sys.Date()`"
output:
  markdown::html_format:
    options:
      toc: true
      number_sections: true
vignette: >
  %\VignetteIndexEntry{Baseline}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(alkahest)
```

```{r raw}
## Load data
data("XRD") # X-ray diffraction

## Subset from 20 to 70 degrees
XRD <- signal_select(XRD, from = 20, to = 70)

## Y plot limits
ylim <- c(0, max(XRD$y))
```

# Linear baseline

```{r linear, fig.width=7, fig.height=6, fig.cap="Linear baseline."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline between 25 and 34 degrees
baseline <- baseline_linear(XRD, points = c(25, 34))

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# Polynomial baseline

```{r polynomial, fig.width=7, fig.height=6, fig.cap="Polynomial baseline."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_polynomial(XRD, d = 4, tolerance = 0.02, stop = 1000)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# Asymmetric Least Squares Smoothing

```{r asls, fig.width=7, fig.height=6, fig.cap="Asymmetric Least Squares Smoothing."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = "Energy (keV)", ylab = "Count")
abline(h = 0, lty = "dashed")

## AsLS baseline
baseline <- baseline_asls(XRD, p = 0.005, lambda = 10^7)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# Rolling Ball baseline

```{r rollingball, fig.width=7, fig.height=6, fig.cap="Rolling Ball baseline."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_rollingball(XRD, m = 201, s = 151)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# Rubberband baseline

```{r rubberband, fig.width=7, fig.height=6, fig.cap="Rubberband baseline."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_rubberband(XRD)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# SNIP baseline

```{r snip, fig.width=7, fig.height=6, fig.cap="SNIP baseline."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = expression(2*theta), ylab = "Count")
abline(h = 0, lty = "dashed")

## Estimate the baseline
baseline <- baseline_snip(XRD, LLS = FALSE, decreasing = FALSE, n = 100)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```

# 4S Peak Filling

```{r peakfilling, fig.width=7, fig.height=6, fig.cap="4S Peak Filling."}
## Plot spectrum
plot(XRD, type = "l", ylim = ylim, xlab = "Energy (keV)", ylab = "Count")
abline(h = 0, lty = "dashed")

## 4S Peak Filling baseline
baseline <- baseline_peakfilling(XRD, n = 10, m = 5, by = 10, 
                                 lambda = 1000, d = 3, sparse = TRUE)

## Plot the baseline
lines(baseline, col = "red")

## Correct spectrum
corrected <- signal_drift(XRD, lag = baseline, subtract = TRUE)

lines(corrected, col = "blue")
```
